import app.landscape
import haproxy

from app.scripts import BaseConfigScript

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        backendMachines = haproxy.HaproxyCluster.get().getBackendMachines("haproxy-gerrit")

        config = []
        for m in sorted(backendMachines, key=lambda m: m.getPhysicalName()):
            # 'check port' lets us use the HTTP health check even though we are balancing here
            # 'check-ssl' causes the health check to be run via SSL
            # 'verify none' causes SSL certificate validation to be skipped
            config.append("\tserver %s %s:%s check port %s check-ssl verify none on-marked-down shutdown-sessions" % (
                m.getPhysicalAddress().getName(), 
                m.getPhysicalAddress().getIp(),
                self.cfg["haproxy-gerrit/dependency/gerrit/ssh-git/port"],
                self.cfg["haproxy-gerrit/dependency/gerrit/http-web/port"]))
            
        return "\n".join(config)