﻿__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.certstore
import haproxy

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Autogenerate/copy SSL certificates"

    def __isSSLEnabled(self):
        return self.cfg.get("SSL", "off") == "on"

    def createRuntime(self):
        if not self.__isSSLEnabled():
            return

        primaryDomainName = self.cfg["haproxy-http/cname/http/host"]
        allDomains = haproxy.HaproxyCluster.get().getBackendFqdns("apache", "http")
        
        
        app.certstore.CertificateGenerator.provisionCertificates(
            primaryDomainName,
            app.certstore.CertificateGenerator.deriveCommonDomain(allDomains),
            self.cfg["SSL_CERT_FILE"],
            self.cfg["SSL_KEY_FILE"],
            self.cfg.get("SSL_CHAIN_FILE"))
        app.certstore.CertificateGenerator.provisionCombinedCertificateFile(primaryDomainName)
