import os
import StringIO
import app.batch

from app.scripts import BaseConfigScript

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        batch = app.batch.ConfigBatch(self.log)
        
        # Add overrides
        for service in app.landscape.Landscape.getSite().getLocalMachine().getServices():
            overridesFolder = os.path.join(
                app.defaults.DEFAULT_SERVICE_DIR, 
                service.getName(),
                'overrides',
                'haproxy', 
                'haproxy.cfg.d-frontend')

            if os.path.isdir(overridesFolder):
                batch = batch.addFolder(overridesFolder)
            
        buffer = StringIO.StringIO()
        try:
            batch.evaluateInto(buffer)
            return buffer.getvalue()
        finally:
            buffer.close()