import app.landscape
import haproxy

from app.scripts import BaseConfigScript

class ConfigScript(BaseConfigScript):

    def configSnippet(self):
        backendMachines = haproxy.HaproxyCluster.get().getBackendMachines("haproxy-mail")

        config = []
        for m in sorted(backendMachines, key=lambda m: m.getPhysicalName()):
            # 'check' enables the health check
            config.append("\tserver %s %s:%s check on-marked-down shutdown-sessions" % (
                m.getPhysicalAddress().getName(), 
                m.getPhysicalAddress().getIp(),
                self.cfg["haproxy-mail/bind/smtp/port"]))
            
        return "\n".join(config)