__copyright__ = "Copyright (c) 2016 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript

import sys
import os
import app.util
import shutil

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Generate haproxy.cfg"

    def createFolderIfNotExisting(self, folder):
        if not os.path.exists(folder):
            try:
                os.makedirs(folder)
            except:
                self.logMesg("warn", "Creating folder %s failed" %folder)

    def createRuntime(self):
        batch = app.batch.ConfigBatch(self.log) \
            .addFolder(os.path.join(app.defaults.DEFAULT_SERVICE_DIR, 'haproxy', 'conf-snippets', 'haproxy.cfg.d'))
            
        # Add overrides
        for service in app.landscape.Landscape.getSite().getLocalMachine().getServices():
            overridesFolder = os.path.join(
                app.defaults.DEFAULT_SERVICE_DIR, 
                service.getName(),
                'overrides',
                'haproxy', 
                'haproxy.cfg.d')

            if os.path.isdir(overridesFolder):
                batch = batch.addFolder(overridesFolder)
            
        batch.evaluateIntoFile("/etc/haproxy/haproxy.cfg")